from bloonix.heaven import H

class Controller:
    def startup(self):
        H.route("/config/services/:id/action/:action", "action")
        self.actions = [
            "acknowledge", "clear-acknowledgement",
            "enable", "disable", "downtime",
            "enable-notifications", "disable-notifications",
            "force-check",
        ]

    def auto(self, opts):
        H.cache["service"] = H.model.db.service.get(opts["id"])
        if not H.cache["service"]:
            return H.plugin.error.set("err-600")
        if opts["action"] not in self.actions:
            return H.plugin.error.set("err-404")
        return True

    def action(self, opts):
        if not H.plugin.token.check():
            return

        service = H.cache["service"]
        service_id = opts["id"]
        action = opts["action"]
        data = {}

        if action == "acknowledge" and service["acknowledged"] == 0:
            data["acknowledged"] = 1
        elif action == "clear-acknowledgement" and service["acknowledged"] == 1:
            data["acknowledged"] = 0
        elif action == "enable" and service["enabled"] == 0:
            data["enabled"] = 1
        elif action == "disable" and service["enabled"] == 1:
            data["enabled"] = 0
        elif action == "enable-notifications" and service["notification_enabled"] == 0:
            data["notification_enabled"] = 1
        elif action == "disable-notifications" and service["notification_enabled"] == 1:
            data["notification_enabled"] = 0
        elif action == "force-check" and service["force_check"] == 0:
            data["force_check"] = 1

        if len(data):
            H.model.db.service.update_by_id(service_id, data)

