from bloonix.heaven import H
from bloonix.exception import BloonixTooMuchObjects

class Controller:
    def startup(self):
        H.route(
            "/config/templates/:id/hosts/member",
            "host_template_member")
        H.route(
            "/config/templates/:id/hosts/no-member",
            "host_template_no_member")
        H.route(
            "/config/templates/:id/hosts/:host_id/add",
            "host_template_add")
        H.route(
            "/config/templates/:id/hosts/:host_id/remove",
            "host_template_remove")

    def host_template_member(self, opts):
        ret = H.model.db.host.query(
            query=H.req.get_query_data(),
            count="id",
            table=[
                "host", [
                    "id", "hostname", "ipaddr1",
                    "project_class", "location_class"
                ]
            ],
            join=[
                "inner", [
                    "host_template",
                    "host.id",
                    "host_template.host_id"
                ]
            ],
            condition=["where", ["host_template.template_id", opts["id"]]],
            order=["asc", "host.id"]
        )

        if ret.success == False:
            return H.plugin.error.set("err-606")

        H.stash.data = ret.data
        H.stash.total = ret.total

    def host_template_no_member(self, opts):
        ret = H.model.db.host.query(
            query=H.req.get_query_data(),
            count="id",
            table=[
                "host", [
                    "id", "hostname", "ipaddr1",
                    "project_class", "location_class"
                ]
            ],
            condition=[
                "where", ["host.id", "not in", {
                    "table": "host_template",
                    "columns": "host_id",
                    "condition": [
                        "where", ["host_template.template_id", opts["id"]]
                    ]
                }]
            ],
            order=["asc", "host.id"]
        )

        if ret.success == False:
            return H.plugin.error.set("err-606")

        H.stash.data = ret.data
        H.stash.total = ret.total

    def host_template_add(self, opts):
        if not H.plugin.token.check():
            return
        try:
            H.model.db.host_template.add_host(opts["id"], opts["host_id"]);
        except BloonixTooMuchObjects:
            return H.plugin.error.set("err-800")

    def host_template_remove(self, opts):
        if not H.plugin.token.check():
            return
        H.model.db.host_template.remove_host(opts["id"], opts["host_id"])
