from bloonix.dbi.crud import CRUDV
from bloonix.heaven.validator import Validator

class Group(CRUDV):
    def __init__(self):
        self.validator = Validator()
        self.validator.set({
            "name": {
                "type": str,
                "minlength": 1,
                "maxlength": 100
            },
            "description": {
                "type": str,
                "minlength": 0,
                "maxlength": 100
            }
        })

    def by_user_id(self, user_id):
        stmt, bind = self.sql.select(
            table=[
                "group", ["id", "name"]
            ],
            join=[
                "inner", ["user_group", "group.id", "user_group.group_id"]
            ],
            condition=[
                "where", ["user_group.user_id", user_id]
            ],
            order=["asc", "group.name"]
        )
        return self.dbi.fetchall(stmt, bind)
