from bloonix.heaven import H

class Role:
    def has_filter_by_group(self):
        if H.user["filter_by_group"] == 1:
            return True
        return False

    def filter_hosts(self, **query):
        return self.__filter("host", **query)

    def filter_host_downtime(self, **query):
        return self.__filter("host_downtime", **query)

    def filter_services(self, **query):
        return self.__filter("service", **query)

    def filter_events(self, **query):
        return self.__filter("event", **query)

    def filter_notifications(self, **query):
        return self.__filter("notification", **query)

    def __filter(self, schema, **query):
        if not H.plugin.role.has_filter_by_group():
            return query

        if "join" not in query:
            query["join"] = []

        query["join"].append("inner")
        if schema == "host":
            query["join"].append([
                "host_group",
                "host.id",
                "host_group.host_id"])
        if schema == "host_downtime":
            query["join"].append([
                "host_group",
                "host_downtime.host_id",
                "host_group.host_id"])
        elif schema == "service":
            query["join"].append([
                "host_group",
                "service.host_id",
                "host_group.host_id"])
        elif schema == "service_downtime":
            query["join"].append([
                "host_group",
                "service_downtime.host_id",
                "host_group.host_id"])
        elif schema == "event":
            query["join"].append([
                "host_group",
                "event.host_id",
                "host_group.host_id"])
        elif schema == "notification":
            query["join"].append([
                "host_group",
                "notification.host_id",
                "host_group.host_id"])

        query["join"].append("inner")
        query["join"].append([
            "user_group",
            "host_group.group_id",
            "user_group.group_id"])

        if "condition" not in query:
            query["condition"] = ["where"]
        else:
            query["condition"].append("and")

        query["condition"].append(["user_group.user_id", H.user["id"]])

        return query
